##
## Loads a MEM trigram model, and uses it to generate
## sequences of given length.
##
##  Usage:   python3 generate.py model.dat length
##

import sys
import random

from MEmodel import MEM, extract_features


## MAIN ---------------------

## -- load MLE trigram model
model = MEM(sys.argv[1])

## length to generate
maxc = int(sys.argv[2])

## set a sentence start initial state "._"
x,y = ".","_"
for i in range(1,maxc) :
  # random selection of next character, according to bigram distribution
  feats = extract_features(x+y)
  z = model.random_transition(feats)
  # print selected character
  if (z=="_") : print(" ", end="")
  else : print(z, end="")
  
  ## shif to new state
  x,y = y,z

print("")

